> For the complete documentation index, see [llms.txt](https://docs.tabnine.com/main/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://docs.tabnine.com/main/getting-started/tabnine-agent/agents-in-action.md).

# Agents in Action

## Creating a Wiki in Notion from the IDE

{% embed url="<https://www.youtube.com/watch?v=tFhhAgmihVo>" %}

## Adding Nullness Annotations to a Java Project

{% embed url="<https://www.youtube.com/watch?v=uwUg1QPfXqY>" %}

In this example, there may be a null pointer exception when the Customer returned from the service is null. However, the built-in static analysis in vscode (and similar tools) is not able to track the data flow in the program and flag that.

```java
public class App {
    public static void main(String[] args) {
        CustomerService customerService = new CustomerService();
        NotificationService notificationService = new NotificationService();

        Customer customer = customerService.getCustomerById("999"); // This is null
        String email = customer.getEmail(); // NPE here!

        notificationService.sendEmail(email, "Welcome!");
    }
}
```

One way to assist the static analysis is to add so called *nullness annotations*. These annotations make tracking dataflow easier by tagging parameters, fields, and return value of functions as `Nullable` or `NotNull`.

After adding the annotations, the agent is able to fix the code to deal with these potential null values. It modifies the code, and the tests to match the new corrected code.


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter:

```
GET https://docs.tabnine.com/main/getting-started/tabnine-agent/agents-in-action.md?ask=<question>
```

The question should be specific, self-contained, and written in natural language.
The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
